Imports Infragistics.Win.UltraWinGrid
Imports Infragistics.Win

Public Class Form1

    Dim dtFrom As New DataTable("Customer1")
    Dim dtTo As New DataTable("Customer2")
    Dim bDeleteSourceRows As Boolean
    Dim iNextKey As Integer

    'load the grids
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ugDragFrom.AllowDrop = True
        ugDragTo.AllowDrop = True
        bDeleteSourceRows = True


        Try

            dtFrom.Columns.Add("CustomerID", GetType(Integer))
            dtFrom.Columns.Add("CustomerName", GetType(String))
            dtFrom.Columns.Add("Address", GetType(String))
            dtFrom.Columns.Add("Date", GetType(DateTime))
            dtFrom.Rows.Add(New Object() {1, "John Lever", "South Street", DateTime.Now})
            dtFrom.Rows.Add(New Object() {2, "Walter Smith", "12/4 S MarkD", DateTime.Now})
            dtFrom.Rows.Add(New Object() {3, "Kathy Lever", "23/45 Honai", DateTime.Now})
            dtFrom.Rows.Add(New Object() {4, "George Wills", "233 Walter Street", DateTime.Now})

            ugDragFrom.DataSource = dtFrom

            dtTo.Columns.Add("CustomerID", GetType(Integer))
            dtTo.Columns.Add("CustomerName", GetType(String))
            dtTo.Columns.Add("Address", GetType(String))
            dtTo.Columns.Add("DateOfJoin", GetType(DateTime))
            dtTo.Rows.Add(New Object() {1, "Joe Schmoe", "North Avenue", DateTime.Now})
            dtTo.Rows.Add(New Object() {2, "Wally Waller", "4567 Johnson", DateTime.Now})
            dtTo.Rows.Add(New Object() {3, "Katie Kane", "2334 Kirk Lane", DateTime.Now})
            dtTo.Rows.Add(New Object() {4, "Geoff Barnes", "533 Bohemia Street", DateTime.Now})
            dtTo.Rows.Add(New Object() {5, "Gene Kelley", "132 Dance Lane", DateTime.Now})
            dtTo.Rows.Add(New Object() {6, "Clark Gable", "345 Double Face Avenue", DateTime.Now})

            ugDragTo.DataSource = dtTo
            iNextKey = 7

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try


    End Sub

    'init the grids layout to have row selectors
    Private Sub UltraGrid_InitializeLayout(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) _
        Handles ugDragFrom.InitializeLayout, ugDragTo.InitializeLayout
        e.Layout.Override.RowSelectors = DefaultableBoolean.True
    End Sub

    'need this so you can drag the selected rows in the drag FROM grid
    Private Sub ugDragFrom_SelectionDrag(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles ugDragFrom.SelectionDrag
        ugDragFrom.DoDragDrop(ugDragFrom.Selected.Rows, DragDropEffects.Copy)
    End Sub

    'need this so the cursor for the drag FROM grid will show
    'DragDropEffects property will show different cursors types abd should be in sync with the drag TO grid
    'a plus sign shows for the All and Copy property
    'comment out line and run to see affect
    Private Sub ugDragFrom_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles ugDragFrom.DragEnter
        e.Effect = DragDropEffects.Copy
    End Sub

    'need this so the cursor for the drag FROM grid will show
    'DragDropEffects property will show different cursors types abd should be in sync with the drag TO grid
    'a plus sign shows for the All and Copy property
    'comment out line and run to see affect
    Private Sub ugDragTo_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles ugDragTo.DragEnter
        e.Effect = DragDropEffects.Copy
    End Sub

    'drop the rows in the drag TO grid, you can use your preferred approach of adding the rows
    Private Sub ugDragTo_DragDrop(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles ugDragTo.DragDrop
        Try

            'get the selected rows - you can trycast ctype or directcast if needed
            'the sender is the drag FROM grid
            '
            Me.ugDragTo.Cursor = Cursors.WaitCursor
            Dim SelRows As SelectedRowsCollection = e.Data.GetData(GetType(SelectedRowsCollection))
            For Each aRow As UltraGridRow In SelRows
                dtTo.Rows.Add(New Object() {iNextKey, _
                                           aRow.Cells("CustomerName").Value, _
                                           aRow.Cells("Address").Value, _
                                           aRow.Cells("Date").Value})
                iNextKey += 1
            Next

            If bDeleteSourceRows = True Then
                'this is not the only way to delete rows
                'use this method if the infragistics release you have has a bug in the DeleteSelectedRows() property
                With SelRows
                    Do While .Count > 0
                        For Each aRow As UltraGridRow In SelRows
                            aRow.Delete(False)
                        Next
                    Loop
                End With
                'ugDragFrom.DeleteSelectedRows(False)
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        Finally
            Me.ugDragTo.Cursor = Cursors.Default
        End Try

    End Sub
End Class
